#!/usr/bin/perl
use strict;

### Set some variables.
my $line_count = 0;
my $new_queue_list;
my $current_line;
my $next_song;
my $queue;
my $pmpg;

### Double-check if we should run the queue ###
if (!(-e "/tmp/.mp3db.paused")) {
 $queue = $ARGV[0] . "queue.list";
 $pmpg = $ARGV[0] . "pmpg123";
 
 ### Read in the queue file. ###
 open (QUEUE_FILE_READ, "$queue") || die "Can't open queue-file - $queue.";
 while (<QUEUE_FILE_READ>) {
  chop;
  ($current_line) = split (/\n/);
  if ( $line_count == "0" ) { $next_song = "$current_line"; }
  if ( $line_count != "0" ) { $new_queue_list = "$new_queue_list$current_line\n"; }
  $line_count++
 }		
 close QUEUE_FILE_READ;
 
 ### Write the new queue file. ###
 open (QUEUE_FILE_WRITE, ">$queue") || die "Can't open queue-file - $queue.";
 if ( $new_queue_list ne "" ) { print QUEUE_FILE_WRITE $new_queue_list; }
 close QUEUE_FILE_WRITE;
 
 ### Finally, if there is another song, start it. ###
 if ( $next_song ne "" ) {
  ### We need to check if we are playing a OGG or a MP3 here.
  if ( $next_song =~ /\.mp3 \"/i ) {
   system("$pmpg $next_song 0 $ARGV[0] 1> /dev/null 2>&1 &");
  } elsif ( $next_song =~ /\.ogg \"/i ) {
   system("$pmpg $next_song 1 $ARGV[0] 1> /dev/null 2>&1 &");
  }
 }
}
